﻿Type=Activity
Version=1.92
FullScreen=False
IncludeTitle=True
@EndOfDesignText@
'Activity module
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

	Dim at As AudioTrack
	Dim Ra As RandomAccessFile
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim BufferSize As Int
	Dim SampleRate As Int
	Dim ChannelConfig As Int
	Dim AudioFormat As Int
	Dim NoChnls,BitsPerSample,DataSize As Int
	
	Dim Play As Thread
	
End Sub

Sub Activity_Create(FirstTime As Boolean)

	Play.Initialise("Play")
	
 
	
	'Open the file for Random Access
	Ra.Initialize2(File.DirRootExternal,"111.wav",True,True)
	
	'Could get this from wav header, but just enter it
	SampleRate=44100
	AudioFormat=at.Af_PCM_16
	NoChnls=2
	ChannelConfig=at.Ch_Conf_Stereo
	
	
	'Get the min buffer size
	BufferSize=at.GetMinBuffersize(SampleRate,ChannelConfig,AudioFormat)
	
	'Try to initialize the player
	at.Initialize(at.Stream_Music,SampleRate,ChannelConfig,AudioFormat,BufferSize,at.Mode_Stream)

	Log(at.GetState)
	'Check it initialized
	If at.GetState < 0 Then
		Msgbox("Failed to initialize AudioTrack","Initialize Failed")
		Activity.Finish
	End If
	at.SetPlaybackRate(at.GetNativeOutputSampleRate(at .Stream_Music)/2)
	'call the playing thread
	Play.Start("Playing",Null)

End Sub

Sub Activity_Resume

End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub
Sub Playing
	Log("Playing")
	Log(Ra.Size)
	Dim Pos As Int
	at.SetStereoVolume(at.GetMaxVolume,at.GetMaxVolume)
	'File has a wav header we need to ignore
	Pos=44
	For i = 0 To Ra.Size-BufferSize Step BufferSize
		'Break into buffersize chunks and write to the AudioTrack
		Dim Dat(BufferSize) As Byte
		Ra.ReadBytes(Dat,0,BufferSize,Pos)
		Log("DL "&Dat.Length)
		Log("Write "&at.WriteByte(Dat,0,BufferSize))
		Pos=Pos+Dat.Length
		If i = 0 Then at.Play
	Next
	
	'Write the last bit
	Dim Dat(Ra.Size-Pos) As Byte
	Ra.ReadBytes(Dat,0,Ra.Size-Pos,Pos)	
	Log("DL "&Dat.Length)
	Log("Write "&at.WriteByte(Dat,0,Ra.Size-Pos))
	
End Sub
Sub Play_Ended(endedOK As Boolean,Error As String)
Log("-----------------------------------------------------Playing Finished")
	Try
	
	at.Release
	Catch
	End Try
	
	Activity.Finish
	
End Sub